unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ExtCtrls, ComCtrls, Grids, StdCtrls, Buttons,
    TLHELP32, PSAPI;

type
    //  vZXƂɌĂяoĂق֐^`
    TCancel = Boolean;
    TProcessFound = function(const ProcessEntry: TProcessEntry32;
                    const Err: Boolean; const ErrText: string): TCancel of object;

type
  TForm1 = class(TForm)
    MainMenu: TMainMenu;
    MenuFile: TMenuItem;
    MenuOption: TMenuItem;
    MenuView: TMenuItem;
    MenuHelp: TMenuItem;
    MenuAbout: TMenuItem;
    MenuExit: TMenuItem;
    MenuRefresh: TMenuItem;
    MenuFrequency: TMenuItem;
    MenuFrequencyHigh: TMenuItem;
    MenuFrequencyNormal: TMenuItem;
    MenuFrequencyLow: TMenuItem;
    MenuFrequencyPause: TMenuItem;
    MenuViewBreak: TMenuItem;
    MenuSelectCol: TMenuItem;
    MenuAlwaysShowTop: TMenuItem;
    Bevel1: TBevel;
    Panel1: TPanel;
    StatusBar: TStatusBar;
    PageControl1: TPageControl;
    TabApplication: TTabSheet;
    TabProcess: TTabSheet;
    TabPerformance: TTabSheet;
    Panel2: TPanel;
    BtnKillProcess: TBitBtn;
    Panel3: TPanel;
    GridProcess: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure GridProcessDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure FormDestroy(Sender: TObject);
  private
    FStrBuf: TStringList; 
    procedure SetGridTitle();
    procedure UpdateProcessList();
    function ProcessFound(const ProcessEntry: TProcessEntry32;
                    const Err: Boolean; const ErrText: string): TCancel;
  private
    FPrivilegeChanged: Boolean;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
    DateUtils, NTPrivilege;

//-----------------------------------------------------------------------------
//  vZXꗗ擾
//  http://nienie.com/~masapico/api_sample_ps05_c.html
//  http://nienie.com/~masapico/api_EnumProcesses.html
//  http://support.microsoft.com/default.aspx?scid=kb;ja;JP175030
//  http://www.borland.co.jp/qanda/delphi/d0003287.html
//  http://www2.big.or.jp/~osamu/Delphi/Tips/key.cgi?key=13
procedure SnapShotProcess(CallBack: TProcessFound);
var
    SnapShot: THandle;
    PE32: TProcessEntry32;
begin
    //  \̂̏
    FillChar(PE32, SizeOf(PE32), 0);
    PE32.dwSize := SizeOf(PE32);

    try
        // VXȅ̃XibvVbgƂ
        SnapShot := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);

        //  ꍇ
        if (SnapShot <> INVALID_HANDLE_VALUE) then
        begin
            try
                // ŏ̃vZX̌
                if Process32First(SnapShot, PE32) then
                begin
                    //  ʒm
                    repeat
                        if CallBack(PE32, False, '') then break;

                    // ̃vZX̌
                    until not Process32Next(SnapShot, PE32);
                end
                //  s
                else CallBack(PE32, False, '');
            finally
                CloseHandle(SnapShot);
            end;
        end
        //  sꍇ
        else
        begin
            CallBack(PE32, True, SysErrorMessage(GetLastError()));
        end;
    except
        on E: Exception do CallBack(PE32, True, E.Message);
    end;
end;

//-----------------------------------------------------------------------------
//  oCg𕶎\
type
    TDispType = (dtNone, dtByte, dtKilo, dtMega);

function B2S(const ByteSize: Int64; const DispType: TDispType): string;
var
    Check: double;
begin
    Check := ByteSize;

    case DispType of

    dtNone:
        begin
            Result := FormatFloat('#,##0', Check);
        end;

    dtByte:
        begin
            Result := FormatFloat('#,##0 B', Check);
        end;

    dtKilo:
        begin
            Check := Check / 1024;
            Result := FormatFloat('#,##0.00 KB', Check);
        end;

    else
        begin
            Check := (Check / 1024) / 1024;
            Result := FormatFloat('#,##0.00 MB', Check);
        end;

    end;
end;

//-----------------------------------------------------------------------------
//  b𕶎\
function SecondToText(const ASeconds: Integer): String;
var
    H, M, MM, S: Integer;
begin
    //  ubv
    S := ASeconds mod 60;

    //  uv
    MM := (ASeconds - S) div 60;

    //  uv
    M := MM mod 60;

    //  uv
    H := MM div 60;

    Result := Format('%4d:%2.2d:%2.2d', [H, M, S])
end;

//-----------------------------------------------------------------------------
type
    //  { ULONGLONG = 64-bit unsigned integer.
    ULONGLONG = Int64;

    //  IO_COUNTERS
    _IO_COUNTERS = packed record
        ReadOperationCount  : ULONGLONG;    //  I/Oǂݎ
        WriteOperationCount : ULONGLONG;    //  I/O
        OtherOperationCount : ULONGLONG;    //  I/Ȏ
        ReadTransferCount   : ULONGLONG;    //  I/OǂݎoCg
        WriteTransferCount  : ULONGLONG;    //  I/O݃oCg
        OtherTransferCount  : ULONGLONG;    //  I/ȎoCg
    end;
    IO_COUNTERS = _IO_COUNTERS;
    PIO_COUNTERS = ^_IO_COUNTERS;
    TIoCounters = _IO_COUNTERS;
    PIoCounters = ^_IO_COUNTERS;

    //  GetProcessIoCounters({̓CgoCfBOׂ)
    function GetProcessIoCounters(
                hProcess: THandle;
                lpIoCounters: PIoCounters
                ): Boolean stdcall; external 'Kernel32.DLL' name 'GetProcessIoCounters';

    //  GetProcessHandleCount
    function GetProcessHandleCount(
                hProcess: THandle;
                pdwHandleCount: PDWORD
                ): Boolean stdcall; external 'Kernel32.DLL' name 'GetProcessHandleCount';

    //  2006.02.04  ProcessIdToSessionId
    function ProcessIdToSessionId(
                dwProcessId: DWORD;
                var pSessionId: DWORD
                ): Boolean stdcall; external 'Kernel32.DLL' name 'ProcessIdToSessionId';

//-----------------------------------------------------------------------------
//  vZX擾
//  http://www.microsoft.com/japan/msdn/library/default.asp?url=/japan/msdn/library/ja/jpperfmo/html/_win32_GetProcessMemoryInfo.asp
//  http://www.ccn.aitai.ne.jp/~ccc/C++/Psapi.txt
//  http://nienie.com/~masapico/api_EmptyWorkingSet.html
function TForm1.ProcessFound(const ProcessEntry: TProcessEntry32;
                    const Err: Boolean; const ErrText: string): TCancel;

    function GetValue(const Valid: Boolean; const Value: string): string;
    begin
        if Valid then Result := Value else Result := '#VAL';
    end;

var
    Grid: TStringGrid;
    hProcess: THandle;
    hProcOpened: Boolean;

    ftCreation: TFileTime;
    ftExitTime: TFileTime;
    ftKernelTime: TFileTime;
    ftUserTime: TFileTime;

    //stCreation: TSystemTime;
    //stExitTime: TSystemTime;
    stKernelTime: TSystemTime;
    stUserTime: TSystemTime;

    //dtCreation: TDateTime;
    //dtExitTime: TDateTime;
    dtKernelTime: TDateTime;
    dtUserTime: TDateTime;

    pmc: TProcessMemoryCounters;
    pio: TIoCounters;
    phc: Cardinal;
    SessionID: DWORD;

    GetProcessTimesOk: Boolean;
    GetProcessMemoryInfoOk: Boolean;
    GetProcessIoCountersOk: Boolean;
    GetProcessHandleCountOk: Boolean;
begin
    Grid := GridProcess;

    //  s𑝂₷
    Grid.RowCount := Grid.RowCount + 1;

    //  G[̏ꍇ͖
    if not Err then
    begin
        //  Zɒ@ޑOɃNA
        FStrBuf.Clear;

        //  ܂vZXnh擾
        hProcess := OpenProcess(
                        PROCESS_QUERY_INFORMATION or PROCESS_VM_READ,
                        False,
                        ProcessEntry.th32ProcessID);

        //  
        hProcOpened := (hProcess <> 0);

        try
            //  C[W
            FStrBuf.Add(ProcessEntry.szExeFile);

            //  PID(vZXID)
            FStrBuf.Add(IntToStr(ProcessEntry.th32ProcessID));

            //  CPUgp
            FStrBuf.Add('-');

            //  CPU
            dtKernelTime := 0;
            dtUserTime := 0;
            GetProcessTimesOk := hProcOpened;
            if (GetProcessTimesOk) then
            begin
                GetProcessTimesOk := GetProcessTimes(hProcess, ftCreation, ftExitTime, ftKernelTime, ftUserTime);
                if (GetProcessTimesOk) then
                begin
                    //  VXeɕϊ
                    //FileTimeToSystemTime(ftCreation, stCreation);
                    //FileTimeToSystemTime(ftExitTime, stExitTime);
                    FileTimeToSystemTime(ftKernelTime, stKernelTime);
                    FileTimeToSystemTime(ftUserTime, stUserTime);
                    //  t^ɕϊ
                    //dtCreation := SystemTimeToDateTime(stCreation);
                    //dtExitTime := SystemTimeToDateTime(stExitTime);
                    dtKernelTime := SystemTimeToDateTime(stKernelTime);
                    dtUserTime := SystemTimeToDateTime(stUserTime);
                end;
            end;

            //  -109205  Ԃ̍ŏl(1601N)
            FStrBuf.Add(GetValue(hProcOpened and GetProcessTimesOk,
                                 SecondToText(SecondsBetween(dtKernelTime + dtUserTime, -109205 * 2))));

            //  \̏
            FillChar(pmc, SizeOf(pmc), 0);
            pmc.cb := SizeOf(pmc);

            //  nh擾łĂ΃擾
            GetProcessMemoryInfoOk := hProcOpened;
            if (GetProcessMemoryInfoOk) then
            begin
                GetProcessMemoryInfoOk := GetProcessMemoryInfo(hProcess, @pmc, SizeOf(pmc));
            end;

            //  gp
            FStrBuf.Add(GetValue(hProcOpened and GetProcessMemoryInfoOk, B2S(pmc.WorkingSetSize, dtKilo)));

            //  gpʃf^
            FStrBuf.Add('-');

            //  ő僁gp
            FStrBuf.Add(GetValue(hProcOpened and GetProcessMemoryInfoOk, B2S(pmc.PeakWorkingSetSize, dtKilo)));

            //  y[WtHg
            FStrBuf.Add(GetValue(hProcOpened and GetProcessMemoryInfoOk, B2S(pmc.PageFaultCount, dtNone)));

            //  USERIuWFNg
            FStrBuf.Add('-');

            //  I/O\̏
            FillChar(pio, SizeOf(pio), 0);

            //  nh擾łĂI/O擾
            GetProcessIoCountersOk := hProcOpened;
            if (GetProcessIoCountersOk) then
            begin
                GetProcessIoCountersOk := GetProcessIoCounters(hProcess, @pio);
            end;

            //  I/Oǂݎ
            FStrBuf.Add(GetValue(hProcOpened and GetProcessIoCountersOk, B2S(pio.ReadOperationCount, dtNone)));

            //  I/OǂݎoCg
            FStrBuf.Add(GetValue(hProcOpened and GetProcessIoCountersOk, B2S(pio.ReadTransferCount, dtNone)));

            //  ZbVID(XP)
            FStrBuf.Add(GetValue(
                        ProcessIdToSessionId(ProcessEntry.th32ProcessID, SessionID),
                        IntToStr(SessionID)
                        ));

            //  [U[(XP)
            FStrBuf.Add('-');

            //  y[WtHgf^
            FStrBuf.Add('-');

            //  zTCY
            FStrBuf.Add(GetValue(hProcOpened and GetProcessMemoryInfoOk, B2S(pmc.PagefileUsage, dtKilo)));

            //  y[Wv[
            FStrBuf.Add(GetValue(hProcOpened and GetProcessMemoryInfoOk, B2S(pmc.QuotaPagedPoolUsage, dtKilo)));

            //  y[Wv[
            FStrBuf.Add(GetValue(hProcOpened and GetProcessMemoryInfoOk, B2S(pmc.QuotaNonPagedPoolUsage, dtKilo)));

            //  2006.02.06  {Dx
            case ProcessEntry.pcPriClassBase of
            0    : FStrBuf.Add(Format('N/A(%d)', [ProcessEntry.pcPriClassBase]));
            1..7 : FStrBuf.Add(Format('H(%d)', [ProcessEntry.pcPriClassBase]));
            8..11: FStrBuf.Add(Format('ʏ(%d)', [ProcessEntry.pcPriClassBase]));
            12   : FStrBuf.Add(Format('H(%d)', [ProcessEntry.pcPriClassBase]));
            13   : FStrBuf.Add(Format('(%d)', [ProcessEntry.pcPriClassBase]));
            else   FStrBuf.Add(Format('H(%d)', [ProcessEntry.pcPriClassBase]));
            end;

            //  nh擾łĂ΃nh擾
            phc := 0;
            GetProcessHandleCountOk := hProcOpened;
            if (GetProcessHandleCountOk) then
            begin
                GetProcessHandleCountOk := GetProcessHandleCount(hProcess, @phc);
            end;

            //  nh̐
            FStrBuf.Add(GetValue(hProcOpened and GetProcessHandleCountOk, B2S(phc, dtNone)));

            //  2006.02.06  Xbh̐
            FStrBuf.Add(B2S(ProcessEntry.cntThreads, dtNone));

            //  GDIIuWFNg
            FStrBuf.Add('-');

            //  I/O
            FStrBuf.Add(GetValue(hProcOpened and GetProcessIoCountersOk, B2S(pio.WriteOperationCount, dtNone)));

            //  I/O݃oCg
            FStrBuf.Add(GetValue(hProcOpened and GetProcessIoCountersOk, B2S(pio.WriteTransferCount, dtNone)));

            //  I/Ȏ
            FStrBuf.Add(GetValue(hProcOpened and GetProcessIoCountersOk, B2S(pio.OtherOperationCount, dtNone)));

            //  I/ȎoCg
            FStrBuf.Add(GetValue(hProcOpened and GetProcessIoCountersOk, B2S(pio.OtherTransferCount, dtNone)));
        finally

            //  2006.02.06  Ĵ͕
            if (hProcOpened) then CloseHandle(hProcess);
        end;

        //  ]L
        Grid.Rows[Grid.RowCount - 1].CommaText := FStrBuf.CommaText;
    end;

    //  SvZX񋓂
    Result := False;
end;

//-----------------------------------------------------------------------------
const
    CELL_MARGIN = 2;

//-----------------------------------------------------------------------------
procedure TForm1.SetGridTitle();
var
    i: Integer;
    Grid: TStringGrid;
begin
    Grid := GridProcess;

    Grid.Rows[0].Clear;
    Grid.Rows[0].CommaText :=
         'C[W,'
         + 'PID,'
         + 'CPU,'
         + 'CPU,'
         + 'gp,'
         + 'f^,'
         + 'ő僁gp,'
         + 'y[WtHg,'
         + 'USERIuWFNg,'
         + 'I/Oǂݎ,'
         + 'I/OǂݎoCg,'
         + 'ZbVID,'
         + '[U[,'
         + 'y[WtHgf^,'
         + 'zTCY,'
         + 'y[Wv[,'
         + 'y[Wv[,'
         + '{Dx,'
         + 'nh,'
         + 'Xbh,'
         + 'GDIIuWFNg,'
         + 'I/O,'
         + 'I/O݃oCg,'
         + 'I/Ȏ,'
         + 'I/ȎoCg'
         ;

    for i := 0 to Grid.ColCount - 1 do
    begin
        Grid.ColWidths[i] := Grid.Canvas.TextWidth(Grid.Cells[i, 0]) + CELL_MARGIN * 2;
    end;
end;

//-----------------------------------------------------------------------------
procedure TForm1.UpdateProcessList();
begin
    GridProcess.RowCount := 1;
    SnapShotProcess(ProcessFound);
    GridProcess.FixedRows := 1;
end;

//-----------------------------------------------------------------------------
//  Programmer's Road
//  http://ag5.net/~prgroad/programming/visualc_mfc/NoryDll.html
procedure TForm1.FormCreate(Sender: TObject);
begin
    //  擾(vZX̃fobO)
    FPrivilegeChanged := NTSetPrivilege(SE_DEBUG_NAME, True);

    FStrBuf := TStringList.Create;

    GridProcess.Canvas.Font.Assign(GridProcess.Font);
    SetGridTitle();

    UpdateProcessList();
end;

//-----------------------------------------------------------------------------
procedure TForm1.FormDestroy(Sender: TObject);
begin
    FreeAndNil(FStrBuf);

    //  
    if (FPrivilegeChanged) then NTSetPrivilege(SE_DEBUG_NAME, False);
end;

//-----------------------------------------------------------------------------
procedure TForm1.GridProcessDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
    Grid: TStringGrid;
    Item: string;
    DrawFormat: Cardinal;
    DrawParams: TDrawTextParams;
    R: TRect;
begin
    Grid := TStringGrid(Sender);

    //  wihԂ
    Grid.Canvas.FillRect(Rect);

    //  o
    Item := Grid.Cells[ACol, ARow];

    //  `ݒ
    DrawFormat := DT_SINGLELINE or DT_VCENTER or DT_WORD_ELLIPSIS;

    //  ^Cgsǂ
    if (ACol * ARow = 0) then
    begin
        DrawFormat := DrawFormat or DT_LEFT;
    end
    else
    begin
        DrawFormat := DrawFormat or DT_RIGHT;
    end;

    //  gݒ
    FillChar(DrawParams, SizeOf(DrawParams), 0);
    DrawParams.cbSize := SizeOf(DrawParams);
    DrawParams.iLeftMargin := CELL_MARGIN;
    DrawParams.iRightMargin := CELL_MARGIN;

    //  `
    R := Rect;
    DrawTextEx(Grid.Canvas.Handle, PChar(Item), -1, R, DrawFormat, @DrawParams);
end;

end.
